#property copyright "Copyright 2006 . (http://www.scalper.ru)"
#property link      "http://www.scalper.ru"


extern int Start1 = 10;
extern int Start2 = 14;
extern int EOD = 24;
extern int FridayClosing = 23;
extern bool FirstSessionOnly = FALSE;
extern int Length = 4;
extern int Pips = 5;
extern int StopLoss = 50;
extern int BreakEven = 30;
extern int TrailingStop = 0;
extern int LossPips = 0;
extern int TakeProfit = 80;
extern double Lots = 0.1;
extern bool MM = TRUE;
extern int LotsPercent = 10;
int gi_140;
int gi_144;
bool gi_148 = TRUE;
double gd_unused_152;
double gd_unused_160;
double gd_unused_168;
double gd_unused_176;
double gd_unused_184;

int init() {
   gi_144 = 3;
//   gi_144 = fnProtect();
   if (gi_144 != 3) {
      if (gi_144 == 1) Alert(" !\n  .    , ,    localinfo.key (      ) !\nhttp://www.scalper.ru");
      if (gi_144 == 2) Alert(" !\n   !\nhttp://www.scalper.ru");
      if (gi_144 == 0) Alert(" !\n  = 0.   ..\nhttp://www.scalper.ru");
      return (0);
   }
   gi_140 = StringGetChar(Symbol(), 0) + 77706 + StringGetChar(Symbol(), 1) << 1 + 3 * StringGetChar(Symbol(), 3) + StringGetChar(Symbol(), 4) << 2 + 10000 * Period();
   gd_unused_152 = MarketInfo(Symbol(), MODE_STOPLEVEL);
   gd_unused_160 = MarketInfo(Symbol(), MODE_SPREAD);
   gd_unused_168 = MarketInfo(Symbol(), MODE_MAXLOT);
   gd_unused_176 = MarketInfo(Symbol(), MODE_MINLOT);
   gd_unused_184 = MarketInfo(Symbol(), MODE_LOTSTEP);
   HideTestIndicators(TRUE);
   return (0);
}

int start() {
   double ld_0;
   string ls_8;
   if (AccountFreeMargin() < 1500.0 * ld_0) return (0);
   if (MM) {
      if (LotsPercent > 0) Lots = NormalizeDouble(MathCeil(AccountFreeMargin() / 10000.0 * LotsPercent) / 10.0, 1);
      else Lots = ld_0;
   }
   if (gi_148) {
      ls_8 = "(c)2006 . HTTP://WWW.SCALPER.RU";
      Comment(ls_8);
   }
   if (gi_144 != 3) {
      if (gi_144 == 1) Comment(" !\n  .    , ,    localinfo.key (      ) !\nhttp://www.scalper.ru");
      if (gi_144 == 2) Comment(" !\n   !\nhttp://www.scalper.ru");
      if (gi_144 == 0) Comment(" !\n  = 0.   ..\nhttp://www.scalper.ru");
      return (0);
   }
   if (EOD >= 24) EOD = 0;
   if (FridayClosing == 0) FridayClosing = 24;
   string ls_28 = "IDS_" + Symbol();
   if (Hour() == Start1 && Minute() < 10) SetOrders(ls_28, 1);
   if (Hour() == Start2 && Minute() < 10 && !FirstSessionOnly) SetOrders(ls_28, 2);
   for (int l_pos_16 = OrdersTotal() - 1; l_pos_16 >= 0; l_pos_16--) {
      OrderSelect(l_pos_16, SELECT_BY_POS);
      if (OrderComment() == ls_28) {
         if (Hour() == EOD || (DayOfWeek() >= 5 && Hour() == FridayClosing - 1 && Minute() >= 50)) {
            switch (OrderType()) {
            case OP_BUY:
               OrderClose(OrderTicket(), OrderLots(), Bid, 3, Red);
               break;
            case OP_SELL:
               OrderClose(OrderTicket(), OrderLots(), Ask, 3, Red);
               break;
            default:
               OrderDelete(OrderTicket());
            }
         } else {
            if (LossPips > 0) {
               if (OrderType() == OP_BUY)
                  if (OrderOpenPrice() - Bid >= LossPips * Point) OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(), OrderOpenPrice(), 0, Green);
               if (OrderType() == OP_SELL)
                  if (Ask - OrderOpenPrice() >= LossPips * Point) OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(), OrderOpenPrice(), 0, Green);
            }
            if (TrailingStop == 0) {
               if (OrderType() == OP_BUY)
                  if (High[0] - OrderOpenPrice() >= BreakEven * Point && OrderStopLoss() < OrderOpenPrice()) OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice(), OrderTakeProfit(), 0, Green);
               if (OrderType() == OP_SELL)
                  if (OrderOpenPrice() - Low[0] >= BreakEven * Point && OrderStopLoss() > OrderOpenPrice()) OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice(), OrderTakeProfit(), 0, Green);
            } else {
               if (OrderType() == OP_BUY)
                  if (High[0] - OrderStopLoss() >= (StopLoss + TrailingStop) * Point) OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss() + TrailingStop * Point, OrderTakeProfit(), 0, Green);
               if (OrderType() == OP_SELL)
                  if (OrderStopLoss() - Low[0] >= (StopLoss + TrailingStop) * Point) OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss() - TrailingStop * Point, OrderTakeProfit(), 0, Green);
            }
         }
      }
   }
   return (0);
}

void SetOrders(string a_comment_0, int a_magic_8) {
   int l_ticket_16;
   int l_count_20 = 0;
   int l_count_24 = 0;
   double ld_28 = iHigh(NULL, PERIOD_H1, iHighest(NULL, PERIOD_H1, MODE_HIGH, Length, 1)) + Pips * Point;
   double ld_36 = iLow(NULL, PERIOD_H1, iLowest(NULL, PERIOD_H1, MODE_LOW, Length, 1)) - Pips * Point;
   double l_price_44 = MathMax(ld_28 - StopLoss * Point, ld_36);
   double l_price_52 = MathMin(ld_36 + StopLoss * Point, ld_28);
   double l_price_60 = ld_28 + TakeProfit * Point;
   double l_price_68 = ld_36 - TakeProfit * Point;
   for (int l_pos_12 = 0; l_pos_12 < OrdersTotal(); l_pos_12++) {
      OrderSelect(l_pos_12, SELECT_BY_POS, MODE_TRADES);
      if (OrderComment() == a_comment_0 && OrderMagicNumber() == a_magic_8) {
         if (OrderType() == OP_BUYSTOP || OrderType() == OP_BUY) l_count_20++;
         if (OrderType() == OP_SELLSTOP || OrderType() == OP_SELL) l_count_24++;
      }
   }
   if (l_count_20 == 0) {
      l_ticket_16 = OrderSend(Symbol(), OP_BUYSTOP, Lots, ld_28, 3, l_price_44, l_price_60, a_comment_0, a_magic_8, 0, Green);
      if (l_ticket_16 < 0 && GetLastError() == 130/* INVALID_STOPS */) l_ticket_16 = OrderSend(Symbol(), OP_BUY, Lots, Ask, 3, l_price_44, l_price_60, a_comment_0, a_magic_8, 0, Green);
   }
   if (l_count_24 == 0) {
      l_ticket_16 = OrderSend(Symbol(), OP_SELLSTOP, Lots, ld_36, 3, l_price_52, l_price_68, a_comment_0, a_magic_8, 0, Green);
      if (l_ticket_16 < 0 && GetLastError() == 130/* INVALID_STOPS */) l_ticket_16 = OrderSend(Symbol(), OP_SELL, Lots, Bid, 3, l_price_52, l_price_68, a_comment_0, a_magic_8, 0, Green);
   }
}
