#property copyright "Copyright 2006 . (http://www.scalper.ru)"
#property link      "http://www.scalper.ru"


extern int MinPrfofit = 1;
extern int MaxLoss = 10;
extern int Delta = 3;
extern int BB_Period = 1;
extern int BB_Deviation = 2;
extern bool FixLotMM = FALSE;
extern double FixLotSize = 0.1;
extern double RiskPercent = 10.0;
extern int Slippage = 2;
extern string Comm = "Mathematical_Analysis";
bool gi_128 = TRUE;
int g_magic_132;
int gi_136;
double g_stoplevel_148;
double g_spread_156;
double g_maxlot_164;
double g_minlot_172;
double g_lotstep_180;
double g_lots_188;
double gd_196;

int init() {
   gi_136 = 3;
//   gi_136 = fnProtect();
   if (gi_136 != 3) {
      if (gi_136 == 1) Alert(" !\n  .    , ,    localinfo.key (      ) !\nhttp://www.scalper.ru");
      if (gi_136 == 2) Alert(" !\n   !\nhttp://www.scalper.ru");
      if (gi_136 == 0) Alert(" !\n  = 0.   .\nhttp://www.scalper.ru");
      return (0);
   }
   g_magic_132 = StringGetChar(Symbol(), 0) + 77704 + StringGetChar(Symbol(), 1) << 1 + 3 * StringGetChar(Symbol(), 3) + StringGetChar(Symbol(), 4) << 2 + 10000 * Period();
   g_stoplevel_148 = MarketInfo(Symbol(), MODE_STOPLEVEL);
   g_spread_156 = MarketInfo(Symbol(), MODE_SPREAD);
   g_maxlot_164 = MarketInfo(Symbol(), MODE_MAXLOT);
   g_minlot_172 = MarketInfo(Symbol(), MODE_MINLOT);
   g_lotstep_180 = MarketInfo(Symbol(), MODE_LOTSTEP);
   HideTestIndicators(TRUE);
   return (0);
}

int start() {
   string ls_0;
   double l_price_12;
   double l_price_20;
   double ld_44;
   bool li_52;
   bool li_56;
   if (gi_128) {
      ls_0 = "(c)2007 . HTTP://WWW.SCALPER.RU";
      Comment(ls_0);
   }
   if (gi_136 != 3) {
      if (gi_136 == 1) Comment(" !\n  .    , ,    localinfo.key (      ) !\nhttp://www.scalper.ru");
      if (gi_136 == 2) Comment(" !\n   !\nhttp://www.scalper.ru");
      if (gi_136 == 0) Comment(" !\n  = 0.   .\nhttp://www.scalper.ru");
      return (0);
   }
   if (!IsTradeAllowed()) {
      Comment("        .");
      return (0);
   } else Comment("");
   if (FixLotMM) g_lots_188 = FixLotSize;
   else g_lots_188 = AccountFreeMargin() / 1000.0 * (RiskPercent / 100.0);
   if (g_lots_188 < g_minlot_172) g_lots_188 = g_minlot_172;
   else {
      if (g_lots_188 > g_maxlot_164) g_lots_188 = g_maxlot_164;
      else {
         for (gd_196 = g_minlot_172; gd_196 <= g_lots_188; gd_196 += g_lotstep_180) {
         }
         g_lots_188 = gd_196 - g_lotstep_180;
      }
   }
   for (int l_pos_8 = OrdersTotal() - 1; l_pos_8 >= 0; l_pos_8--) {
      OrderSelect(l_pos_8, SELECT_BY_POS);
      if (OrderSymbol() != Symbol() || OrderMagicNumber() != g_magic_132) continue;
      if (OrderType() == OP_BUY) {
         ld_44 = Bid - OrderOpenPrice();
         if ((MinPrfofit > 0 && ld_44 >= MinPrfofit * Point) || (MaxLoss > 0 && ld_44 <= (-1 * MaxLoss) * Point)) {
            OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, Purple);
            return (0);
         }
      }
      if (OrderType() == OP_SELL) {
         ld_44 = OrderOpenPrice() - Ask;
         if ((MinPrfofit > 0 && ld_44 >= MinPrfofit * Point) || (MaxLoss > 0 && ld_44 <= (-1 * MaxLoss) * Point)) {
            OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, Red);
            return (0);
         }
      }
      return (0);
   }
   double l_ibands_28 = iBands(Symbol(), 0, BB_Period, BB_Deviation, 0, PRICE_OPEN, MODE_UPPER, 0);
   double l_ibands_36 = iBands(Symbol(), 0, BB_Period, BB_Deviation, 0, PRICE_OPEN, MODE_LOWER, 0);
   if (Close[0] > l_ibands_28 + Delta * Point) li_56 = TRUE;
   else li_56 = FALSE;
   if (Close[0] < l_ibands_36 - Delta * Point) li_52 = TRUE;
   else li_52 = FALSE;
   if (li_52) {
      if (MaxLoss == 0) l_price_12 = 0;
      else l_price_12 = Ask - (MaxLoss + g_stoplevel_148) * Point;
      if (MinPrfofit == 0) l_price_20 = 0;
      else l_price_20 = Ask + (MinPrfofit + g_stoplevel_148 + g_spread_156) * Point;
      OrderSend(Symbol(), OP_BUY, g_lots_188, Ask, Slippage, l_price_12, l_price_20, Comm, g_magic_132, 16711680);
   }
   if (li_56) {
      if (MaxLoss == 0) l_price_12 = 0;
      else l_price_12 = Bid + (MaxLoss + g_stoplevel_148) * Point;
      if (MinPrfofit == 0) l_price_20 = 0;
      else l_price_20 = Bid - (MinPrfofit + g_stoplevel_148 + g_spread_156) * Point;
      OrderSend(Symbol(), OP_SELL, g_lots_188, Bid, Slippage, l_price_12, l_price_20, Comm, g_magic_132, 255);
   }
   return (0);
}
