#property copyright "Copyright 2006 . (http://www.scalper.ru)"
#property link      "http://www.scalper.ru"

extern int PeriodHL = 25;
extern int Slippage = 3;
extern int TakeProfit = 15;
extern bool Reverse = FALSE;
extern bool FixLotMM = FALSE;
extern double FixLotSize = 0.1;
extern double RiskPercent = 10.0;
extern string Comm = "RealTrade";
double g_maxlot_120;
double g_minlot_128;
double g_lotstep_136;
double gd_144;
double g_lots_152;
double gd_160;
int g_magic_168;
int gi_172;
int gi_176;
bool gi_180 = TRUE;

void init() {
   gi_176 = 3;
//   gi_176 = fnProtect();
   if (gi_176 != 3) {
      if (gi_176 == 1) Alert(" !\n  .    , ,    localinfo.key (      ) !\nhttp://www.scalper.ru");
      if (gi_176 == 2) Alert(" !\n   !\nhttp://www.scalper.ru");
      if (gi_176 == 0) Alert(" !\n  = 0.   .\nhttp://www.scalper.ru");
   } else {
      g_magic_168 = StringGetChar(Symbol(), 0) + 77701 + StringGetChar(Symbol(), 1) << 1 + 3 * StringGetChar(Symbol(), 3) + StringGetChar(Symbol(), 4) << 2 + 10000 * Period();
      g_maxlot_120 = MarketInfo(Symbol(), MODE_MAXLOT);
      g_minlot_128 = MarketInfo(Symbol(), MODE_MINLOT);
      g_lotstep_136 = MarketInfo(Symbol(), MODE_LOTSTEP);
   }
}

void start() {
   string ls_0;
   double ld_8;
   double ld_16;
   if (gi_180) {
      ls_0 = "(c)2007 . HTTP://WWW.SCALPER.RU";
      Comment(ls_0);
   }
   if (gi_176 != 3) {
      if (gi_176 == 1) Comment(" !\n  .    , ,    localinfo.key (      ) !\nhttp://www.scalper.ru");
      if (gi_176 == 2) Comment(" !\n   !\nhttp://www.scalper.ru");
      if (gi_176 == 0) Comment(" !\n  = 0.   .\nhttp://www.scalper.ru");
   } else {
      if (!IsTradeAllowed()) {
         Comment("        .");
         return;
      } else Comment("");
      if (FixLotMM) g_lots_152 = FixLotSize;
      else g_lots_152 = AccountFreeMargin() / 1000.0 * (RiskPercent / 100.0);
      if (g_lots_152 < g_minlot_128) g_lots_152 = g_minlot_128;
      else {
         if (g_lots_152 > g_maxlot_120) g_lots_152 = g_maxlot_120;
         else {
            for (gd_144 = g_minlot_128; gd_144 <= g_lots_152; gd_144 += g_lotstep_136) {
            }
            g_lots_152 = gd_144 - g_lotstep_136;
         }
      }
      ld_8 = High[iHighest(NULL, 0, MODE_HIGH, PeriodHL, 1)];
      ld_16 = Low[iLowest(NULL, 0, MODE_LOW, PeriodHL, 1)];
      gi_172 = -1;
      if (Close[0] < ld_16) {
         if (Reverse) gi_172 = 1;
         else gi_172 = 0;
      }
      if (Close[0] > ld_8) {
         if (Reverse) gi_172 = 0;
         else gi_172 = 1;
      }
      for (int l_pos_24 = OrdersTotal() - 1; l_pos_24 >= 0; l_pos_24--) {
         OrderSelect(l_pos_24, SELECT_BY_POS);
         if (OrderSymbol() != Symbol() || OrderMagicNumber() != g_magic_168) continue;
         if (OrderType() == OP_BUY) {
            if (gi_172 == 1) {
               OrderClose(OrderTicket(), OrderLots(), Bid, 3, CLR_NONE);
               return;
            }
            if (gd_160 > Bid + TakeProfit * Point) gd_160 = Bid + TakeProfit * Point;
            if (Bid < gd_160) return;
            OrderClose(OrderTicket(), OrderLots(), Bid, 3, CLR_NONE);
         } else {
            if (OrderType() == OP_SELL) {
               if (gi_172 == 0) OrderClose(OrderTicket(), OrderLots(), Ask, 3, CLR_NONE);
               else {
                  if (gd_160 < Ask - TakeProfit * Point) gd_160 = Ask - TakeProfit * Point;
                  if (Ask <= gd_160) OrderClose(OrderTicket(), OrderLots(), Ask, 3, CLR_NONE);
               }
            }
         }
         return;
      }
      if (gi_172 == 0) {
         OrderSend(Symbol(), OP_BUY, g_lots_152, Ask, Slippage, 0, 0, Comm, g_magic_168, 0, Red);
         gd_160 = Bid + TakeProfit * Point;
         return;
      }
      if (gi_172 == 1) {
         OrderSend(Symbol(), OP_SELL, g_lots_152, Bid, Slippage, 0, 0, Comm, g_magic_168, 0, Blue);
         gd_160 = Ask - TakeProfit * Point;
      }
   }
}
