#property copyright "Copyright 2006 . (http://www.scalper.ru)"
#property link      "http://www.scalper.ru"

extern double Koeff = 0.7;
extern int ProcOfClose = 5;
extern double Up = 95.0;
extern double Down = -95.0;
extern double MAPeriod = 6.0;
extern double TakeProfit = 0.0;
extern double StopLoss = 0.0;
extern int Trail = 50;
extern int StepTrail = 10;
extern bool FixLotMM = FALSE;
extern double FixLotSize = 0.1;
extern double RiskPercent = 20.0;
extern string Comm = "Bank Trade system";
int g_magic_164;
int gi_168;
double g_lots_172;
double g_stoplevel_196;
double gd_unused_204;
double g_maxlot_212;
double g_minlot_220;
double g_lotstep_228;
bool gi_244 = TRUE;

int init() {
   gi_168 = 3;
//   gi_168 = fnProtect();
   if (gi_168 != 3) {
      if (gi_168 == 1) Alert(" !\n  .    , ,    localinfo.key (      ) !\nhttp://www.scalper.ru");
      if (gi_168 == 2) Alert(" !\n   !\nhttp://www.scalper.ru");
      if (gi_168 == 0) Alert(" !\n  = 0.   .\nhttp://www.scalper.ru");
      return (0);
   }
   g_magic_164 = StringGetChar(Symbol(), 0) + 77706 + StringGetChar(Symbol(), 1) << 1 + 3 * StringGetChar(Symbol(), 3) + StringGetChar(Symbol(), 4) << 2 + 10000 * Period();
   g_stoplevel_196 = MarketInfo(Symbol(), MODE_STOPLEVEL);
   gd_unused_204 = MarketInfo(Symbol(), MODE_SPREAD);
   g_maxlot_212 = MarketInfo(Symbol(), MODE_MAXLOT);
   g_minlot_220 = MarketInfo(Symbol(), MODE_MINLOT);
   g_lotstep_228 = MarketInfo(Symbol(), MODE_LOTSTEP);
   HideTestIndicators(TRUE);
   return (0);
}

int start() {
   double l_price_16;
   double l_price_24;
   string ls_80;
   string ls_unused_88;
   if (gi_244) {
      ls_unused_88 = "(c)2006 . HTTP://WWW.SCALPER.RU";
      Comment(ls_80);
   }
   if (gi_168 != 3) {
      if (gi_168 == 1) Comment(" !\n  .    , ,    localinfo.key (      ) !\nhttp://www.scalper.ru");
      if (gi_168 == 2) Comment(" !\n   !\nhttp://www.scalper.ru");
      if (gi_168 == 0) Comment(" !\n  = 0.   .\nhttp://www.scalper.ru");
      return (0);
   }
   if (!IsTradeAllowed()) {
      Comment("        .");
      return (0);
   } else Comment("");
   if (FixLotMM) g_lots_172 = FixLotSize;
   else g_lots_172 = AccountFreeMargin() / 1000.0 * (RiskPercent / 100.0);
   if (g_lots_172 < g_minlot_220) g_lots_172 = g_minlot_220;
   else {
      if (g_lots_172 > g_maxlot_212) g_lots_172 = g_maxlot_212;
      else {
         for (double ld_40 = g_minlot_220; ld_40 <= g_lots_172; ld_40 += g_lotstep_228) {
         }
         g_lots_172 = ld_40 - g_lotstep_228;
      }
   }
   double l_icci_0 = iCCI(Symbol(), 0, 17, PRICE_CLOSE, 0);
   double l_ticket_8 = SHI_Laquerre(0);
   double l_ima_56 = iMA(Symbol(), 0, MAPeriod, 0, MODE_EMA, PRICE_MEDIAN, 0);
   double l_ima_64 = iMA(Symbol(), 0, MAPeriod, 0, MODE_EMA, PRICE_MEDIAN, 1);
   for (int l_pos_72 = 0; l_pos_72 < OrdersTotal(); l_pos_72++) {
      OrderSelect(l_pos_72, SELECT_BY_POS);
      if (OrderSymbol() != Symbol() || OrderMagicNumber() != g_magic_164) continue;
      if (OrderType() == OP_BUY) {
         if (l_ticket_8 > ProcOfClose / 100.0) OrderClose(OrderTicket(), OrderLots(), Ask, 3, CLR_NONE);
         else
            if (Trail > 0 && Bid - OrderOpenPrice() > StopLoss * Point && OrderStopLoss() < Bid - (Trail + StepTrail) * Point) OrderModify(OrderTicket(), OrderOpenPrice(), Bid - Trail * Point, OrderTakeProfit(), 0, CLR_NONE);
      } else {
         if (OrderType() == OP_SELL) {
            if (l_ticket_8 < (100.0 - ProcOfClose) / 100.0) OrderClose(OrderTicket(), OrderLots(), Bid, 3, CLR_NONE);
            else
               if (Trail > 0 && OrderOpenPrice() - Ask > StopLoss * Point && OrderStopLoss() > Ask + (Trail + StepTrail) * Point) OrderModify(OrderTicket(), OrderOpenPrice(), Ask + Trail * Point, OrderTakeProfit(), 0, CLR_NONE);
         }
      }
      return (0);
   }
   if (l_ticket_8 == 0.0 && l_ima_56 > l_ima_64 && l_icci_0 < Down) {
      if (StopLoss < g_stoplevel_196) l_price_16 = 0;
      else l_price_16 = Ask - StopLoss * Point;
      if (TakeProfit < g_stoplevel_196) l_price_24 = 0;
      else l_price_24 = Ask + TakeProfit * Point;
      OrderSend(Symbol(), OP_BUY, g_lots_172, Ask, 3, l_price_16, l_price_24, Comm, g_magic_164, 0, Red);
   }
   if (l_ticket_8 == 1.0 && l_ima_56 < l_ima_64 && l_icci_0 > Up) {
      if (StopLoss < g_stoplevel_196) l_price_16 = 0;
      else l_price_16 = Bid + StopLoss * Point;
      if (TakeProfit < g_stoplevel_196) l_price_24 = 0;
      else l_price_24 = Bid - TakeProfit * Point;
      OrderSend(Symbol(), OP_SELL, g_lots_172, Bid, 3, l_price_16, l_price_24, Comm, g_magic_164, 0, Blue);
   }
   return (0);
}

double SHI_Laquerre(int ai_0) {
   double ld_ret_4;
   double lda_12[100];
   double lda_16[100];
   double lda_20[100];
   double lda_24[100];
   double ld_28;
   double ld_36;
   for (int li_44 = ai_0 + 99; li_44 >= ai_0; li_44--) {
      lda_12[li_44] = (1 - Koeff) * Close[li_44] + Koeff * (lda_12[li_44 + 1]);
      lda_16[li_44] = (-Koeff) * lda_12[li_44] + (lda_12[li_44 + 1]) + Koeff * (lda_16[li_44 + 1]);
      lda_20[li_44] = (-Koeff) * lda_16[li_44] + (lda_16[li_44 + 1]) + Koeff * (lda_20[li_44 + 1]);
      lda_24[li_44] = (-Koeff) * lda_20[li_44] + (lda_20[li_44 + 1]) + Koeff * (lda_24[li_44 + 1]);
      ld_28 = 0;
      ld_36 = 0;
      if (lda_12[li_44] >= lda_16[li_44]) ld_28 = lda_12[li_44] - lda_16[li_44];
      else ld_36 = lda_16[li_44] - lda_12[li_44];
      if (lda_16[li_44] >= lda_20[li_44]) ld_28 += lda_16[li_44] - lda_20[li_44];
      else ld_36 += lda_20[li_44] - lda_16[li_44];
      if (lda_20[li_44] >= lda_24[li_44]) ld_28 += lda_20[li_44] - lda_24[li_44];
      else ld_36 += lda_24[li_44] - lda_20[li_44];
      if (ld_28 + ld_36 != 0.0) ld_ret_4 = ld_28 / (ld_28 + ld_36);
   }
   return (ld_ret_4);
}
